Index: branches/MemPRAlgorithm/HeuristicLab.Analysis.Views/3.3/ScatterPlotView.cs
===================================================================
--- branches/MemPRAlgorithm/HeuristicLab.Analysis.Views/3.3/ScatterPlotView.cs	(revision 14557)
+++ branches/MemPRAlgorithm/HeuristicLab.Analysis.Views/3.3/ScatterPlotView.cs	(revision 14562)
@@ -21,11 +21,5 @@
 
 using System;
-using System.Collections.Generic;
-using System.Drawing;
-using System.Linq;
 using System.Windows.Forms;
-using System.Windows.Forms.DataVisualization.Charting;
-using HeuristicLab.Collections;
-using HeuristicLab.Common;
 using HeuristicLab.Core.Views;
 using HeuristicLab.MainForm;
@@ -35,7 +29,4 @@
   [Content(typeof(ScatterPlot), true)]
   public partial class ScatterPlotView : NamedItemView, IConfigureableView {
-    protected List<Series> invisibleSeries;
-    protected Dictionary<IObservableList<Point2D<double>>, ScatterPlotDataRow> pointsRowsTable;
-    private double xMin, xMax, yMin, yMax;
 
     public new ScatterPlot Content {
@@ -46,64 +37,9 @@
     public ScatterPlotView() {
       InitializeComponent();
-      pointsRowsTable = new Dictionary<IObservableList<Point2D<double>>, ScatterPlotDataRow>();
-      invisibleSeries = new List<Series>();
-      chart.CustomizeAllChartAreas();
-      chart.ChartAreas[0].CursorX.Interval = 1;
     }
-
-    #region Event Handler Registration
-    protected override void DeregisterContentEvents() {
-      foreach (ScatterPlotDataRow row in Content.Rows)
-        DeregisterScatterPlotDataRowEvents(row);
-      Content.VisualPropertiesChanged -= new EventHandler(Content_VisualPropertiesChanged);
-      Content.Rows.ItemsAdded -= new CollectionItemsChangedEventHandler<ScatterPlotDataRow>(Rows_ItemsAdded);
-      Content.Rows.ItemsRemoved -= new CollectionItemsChangedEventHandler<ScatterPlotDataRow>(Rows_ItemsRemoved);
-      Content.Rows.ItemsReplaced -= new CollectionItemsChangedEventHandler<ScatterPlotDataRow>(Rows_ItemsReplaced);
-      Content.Rows.CollectionReset -= new CollectionItemsChangedEventHandler<ScatterPlotDataRow>(Rows_CollectionReset);
-      base.DeregisterContentEvents();
-    }
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.VisualPropertiesChanged += new EventHandler(Content_VisualPropertiesChanged);
-      Content.Rows.ItemsAdded += new CollectionItemsChangedEventHandler<ScatterPlotDataRow>(Rows_ItemsAdded);
-      Content.Rows.ItemsRemoved += new CollectionItemsChangedEventHandler<ScatterPlotDataRow>(Rows_ItemsRemoved);
-      Content.Rows.ItemsReplaced += new CollectionItemsChangedEventHandler<ScatterPlotDataRow>(Rows_ItemsReplaced);
-      Content.Rows.CollectionReset += new CollectionItemsChangedEventHandler<ScatterPlotDataRow>(Rows_CollectionReset);
-    }
-
-    protected virtual void RegisterScatterPlotDataRowEvents(ScatterPlotDataRow row) {
-      row.NameChanged += new EventHandler(Row_NameChanged);
-      row.VisualPropertiesChanged += new EventHandler(Row_VisualPropertiesChanged);
-      pointsRowsTable.Add(row.Points, row);
-      row.Points.ItemsAdded += new CollectionItemsChangedEventHandler<IndexedItem<Point2D<double>>>(Points_ItemsAdded);
-      row.Points.ItemsRemoved += new CollectionItemsChangedEventHandler<IndexedItem<Point2D<double>>>(Points_ItemsRemoved);
-      row.Points.ItemsReplaced += new CollectionItemsChangedEventHandler<IndexedItem<Point2D<double>>>(Points_ItemsReplaced);
-      row.Points.CollectionReset += new CollectionItemsChangedEventHandler<IndexedItem<Point2D<double>>>(Points_CollectionReset);
-    }
-    protected virtual void DeregisterScatterPlotDataRowEvents(ScatterPlotDataRow row) {
-      row.Points.ItemsAdded -= new CollectionItemsChangedEventHandler<IndexedItem<Point2D<double>>>(Points_ItemsAdded);
-      row.Points.ItemsRemoved -= new CollectionItemsChangedEventHandler<IndexedItem<Point2D<double>>>(Points_ItemsRemoved);
-      row.Points.ItemsReplaced -= new CollectionItemsChangedEventHandler<IndexedItem<Point2D<double>>>(Points_ItemsReplaced);
-      row.Points.CollectionReset -= new CollectionItemsChangedEventHandler<IndexedItem<Point2D<double>>>(Points_CollectionReset);
-      pointsRowsTable.Remove(row.Points);
-      row.VisualPropertiesChanged -= new EventHandler(Row_VisualPropertiesChanged);
-      row.NameChanged -= new EventHandler(Row_NameChanged);
-    }
-    #endregion
 
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      invisibleSeries.Clear();
-      chart.Titles[0].Text = string.Empty;
-      chart.ChartAreas[0].AxisX.Title = string.Empty;
-      chart.ChartAreas[0].AxisY.Title = string.Empty;
-      chart.Series.Clear();
-      if (Content != null) {
-        chart.Titles[0].Text = Content.Name;
-        AddScatterPlotDataRows(Content.Rows);
-        ConfigureChartArea(chart.ChartAreas[0]);
-        RecalculateMinMaxPointValues();
-        RecalculateAxesScale(chart.ChartAreas[0]);
-      }
+      chart.Content = Content;
     }
 
@@ -114,138 +50,7 @@
 
     public void ShowConfiguration() {
-      if (Content != null) {
-        using (ScatterPlotVisualPropertiesDialog dialog = new ScatterPlotVisualPropertiesDialog(Content)) {
-          dialog.ShowDialog(this);
-        }
-      } else MessageBox.Show("Nothing to configure.");
+      chart.ShowConfiguration();
     }
 
-    protected virtual void AddScatterPlotDataRows(IEnumerable<ScatterPlotDataRow> rows) {
-      foreach (var row in rows) {
-        RegisterScatterPlotDataRowEvents(row);
-        Series series = new Series(row.Name);
-        if (row.VisualProperties.DisplayName.Trim() != String.Empty) series.LegendText = row.VisualProperties.DisplayName;
-        else series.LegendText = row.Name;
-        ConfigureSeries(series, row);
-        FillSeriesWithRowValues(series, row);
-        chart.Series.Add(series);
-      }
-      ConfigureChartArea(chart.ChartAreas[0]);
-      RecalculateMinMaxPointValues();
-      RecalculateAxesScale(chart.ChartAreas[0]);
-      UpdateYCursorInterval();
-    }
-
-    protected virtual void RemoveScatterPlotDataRows(IEnumerable<ScatterPlotDataRow> rows) {
-      foreach (var row in rows) {
-        DeregisterScatterPlotDataRowEvents(row);
-        Series series = chart.Series[row.Name];
-        chart.Series.Remove(series);
-        if (invisibleSeries.Contains(series))
-          invisibleSeries.Remove(series);
-      }
-      RecalculateMinMaxPointValues();
-      RecalculateAxesScale(chart.ChartAreas[0]);
-    }
-
-    private void ConfigureSeries(Series series, ScatterPlotDataRow row) {
-      series.BorderWidth = 1;
-      series.BorderDashStyle = ChartDashStyle.Solid;
-      series.BorderColor = Color.Empty;
-
-      if (row.VisualProperties.Color != Color.Empty)
-        series.Color = row.VisualProperties.Color;
-      else series.Color = Color.Empty;
-      series.IsVisibleInLegend = row.VisualProperties.IsVisibleInLegend;
-      series.ChartType = SeriesChartType.FastPoint;
-      series.MarkerSize = row.VisualProperties.PointSize;
-      series.MarkerStyle = ConvertPointStyle(row.VisualProperties.PointStyle);
-      series.XAxisType = AxisType.Primary;
-      series.YAxisType = AxisType.Primary;
-
-      if (row.VisualProperties.DisplayName.Trim() != String.Empty) series.LegendText = row.VisualProperties.DisplayName;
-      else series.LegendText = row.Name;
-
-      string xAxisTitle = string.IsNullOrEmpty(Content.VisualProperties.XAxisTitle)
-                      ? "X"
-                      : Content.VisualProperties.XAxisTitle;
-      string yAxisTitle = string.IsNullOrEmpty(Content.VisualProperties.YAxisTitle)
-                            ? "Y"
-                            : Content.VisualProperties.YAxisTitle;
-      series.ToolTip =
-        series.LegendText + Environment.NewLine +
-        xAxisTitle + " = " + "#VALX," + Environment.NewLine +
-        yAxisTitle + " = " + "#VAL";
-    }
-
-    private void ConfigureChartArea(ChartArea area) {
-      if (Content.VisualProperties.TitleFont != null) chart.Titles[0].Font = Content.VisualProperties.TitleFont;
-      if (!Content.VisualProperties.TitleColor.IsEmpty) chart.Titles[0].ForeColor = Content.VisualProperties.TitleColor;
-      chart.Titles[0].Text = Content.VisualProperties.Title;
-
-      if (Content.VisualProperties.AxisTitleFont != null) area.AxisX.TitleFont = Content.VisualProperties.AxisTitleFont;
-      if (!Content.VisualProperties.AxisTitleColor.IsEmpty) area.AxisX.TitleForeColor = Content.VisualProperties.AxisTitleColor;
-      area.AxisX.Title = Content.VisualProperties.XAxisTitle;
-      area.AxisX.MajorGrid.Enabled = Content.VisualProperties.XAxisGrid;
-
-      if (Content.VisualProperties.AxisTitleFont != null) area.AxisY.TitleFont = Content.VisualProperties.AxisTitleFont;
-      if (!Content.VisualProperties.AxisTitleColor.IsEmpty) area.AxisY.TitleForeColor = Content.VisualProperties.AxisTitleColor;
-      area.AxisY.Title = Content.VisualProperties.YAxisTitle;
-      area.AxisY.MajorGrid.Enabled = Content.VisualProperties.YAxisGrid;
-    }
-
-    private void RecalculateAxesScale(ChartArea area) {
-      area.AxisX.Minimum = CalculateMinBound(xMin);
-      area.AxisX.Maximum = CalculateMaxBound(xMax);
-      if (area.AxisX.Minimum == area.AxisX.Maximum) {
-        area.AxisX.Minimum = xMin - 0.5;
-        area.AxisX.Maximum = xMax + 0.5;
-      }
-      area.AxisY.Minimum = CalculateMinBound(yMin);
-      area.AxisY.Maximum = CalculateMaxBound(yMax);
-      if (area.AxisY.Minimum == area.AxisY.Maximum) {
-        area.AxisY.Minimum = yMin - 0.5;
-        area.AxisY.Maximum = yMax + 0.5;
-      }
-      if (xMax - xMin > 0) area.CursorX.Interval = Math.Pow(10, Math.Floor(Math.Log10(area.AxisX.Maximum - area.AxisX.Minimum) - 3));
-      else area.CursorX.Interval = 1;
-      area.AxisX.IsMarginVisible = false;
-
-      if (!Content.VisualProperties.XAxisMinimumAuto && !double.IsNaN(Content.VisualProperties.XAxisMinimumFixedValue)) area.AxisX.Minimum = Content.VisualProperties.XAxisMinimumFixedValue;
-      if (!Content.VisualProperties.XAxisMaximumAuto && !double.IsNaN(Content.VisualProperties.XAxisMaximumFixedValue)) area.AxisX.Maximum = Content.VisualProperties.XAxisMaximumFixedValue;
-      if (!Content.VisualProperties.YAxisMinimumAuto && !double.IsNaN(Content.VisualProperties.YAxisMinimumFixedValue)) area.AxisY.Minimum = Content.VisualProperties.YAxisMinimumFixedValue;
-      if (!Content.VisualProperties.YAxisMaximumAuto && !double.IsNaN(Content.VisualProperties.YAxisMaximumFixedValue)) area.AxisY.Maximum = Content.VisualProperties.YAxisMaximumFixedValue;
-    }
-
-    private static double CalculateMinBound(double min) {
-      if (min == 0) return 0;
-      var scale = Math.Pow(10, Math.Floor(Math.Log10(Math.Abs(min))));
-      return scale * (Math.Floor(min / scale));
-    }
-
-    private static double CalculateMaxBound(double max) {
-      if (max == 0) return 0;
-      var scale = Math.Pow(10, Math.Floor(Math.Log10(Math.Abs(max))));
-      return scale * (Math.Ceiling(max / scale));
-    }
-
-    protected virtual void UpdateYCursorInterval() {
-      double interestingValuesRange = (
-        from series in chart.Series
-        where series.Enabled
-        let values = (from point in series.Points
-                      where !point.IsEmpty
-                      select point.YValues[0]).DefaultIfEmpty(1.0)
-        let range = values.Max() - values.Min()
-        where range > 0.0
-        select range
-        ).DefaultIfEmpty(1.0).Min();
-
-      double digits = (int)Math.Log10(interestingValuesRange) - 3;
-      double yZoomInterval = Math.Pow(10, digits);
-      this.chart.ChartAreas[0].CursorY.Interval = yZoomInterval;
-    }
-
-    #region Event Handlers
     #region Content Event Handlers
     protected override void Content_NameChanged(object sender, EventArgs e) {
@@ -253,252 +58,7 @@
         Invoke(new EventHandler(Content_NameChanged), sender, e);
       else {
-        chart.Titles[0].Text = Content.Name;
+        Content.VisualProperties.Title = Content.Name;
         base.Content_NameChanged(sender, e);
       }
-    }
-    private void Content_VisualPropertiesChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Content_VisualPropertiesChanged), sender, e);
-      else {
-        ConfigureChartArea(chart.ChartAreas[0]);
-        RecalculateAxesScale(chart.ChartAreas[0]); // axes min/max could have changed
-      }
-    }
-    #endregion
-    #region Rows Event Handlers
-    private void Rows_ItemsAdded(object sender, CollectionItemsChangedEventArgs<ScatterPlotDataRow> e) {
-      if (InvokeRequired)
-        Invoke(new CollectionItemsChangedEventHandler<ScatterPlotDataRow>(Rows_ItemsAdded), sender, e);
-      else {
-        AddScatterPlotDataRows(e.Items);
-      }
-    }
-    private void Rows_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<ScatterPlotDataRow> e) {
-      if (InvokeRequired)
-        Invoke(new CollectionItemsChangedEventHandler<ScatterPlotDataRow>(Rows_ItemsRemoved), sender, e);
-      else {
-        RemoveScatterPlotDataRows(e.Items);
-      }
-    }
-    private void Rows_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<ScatterPlotDataRow> e) {
-      if (InvokeRequired)
-        Invoke(new CollectionItemsChangedEventHandler<ScatterPlotDataRow>(Rows_ItemsReplaced), sender, e);
-      else {
-        RemoveScatterPlotDataRows(e.OldItems);
-        AddScatterPlotDataRows(e.Items);
-      }
-    }
-    private void Rows_CollectionReset(object sender, CollectionItemsChangedEventArgs<ScatterPlotDataRow> e) {
-      if (InvokeRequired)
-        Invoke(new CollectionItemsChangedEventHandler<ScatterPlotDataRow>(Rows_CollectionReset), sender, e);
-      else {
-        RemoveScatterPlotDataRows(e.OldItems);
-        AddScatterPlotDataRows(e.Items);
-      }
-    }
-    #endregion
-    #region Row Event Handlers
-    private void Row_VisualPropertiesChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Row_VisualPropertiesChanged), sender, e);
-      else {
-        ScatterPlotDataRow row = (ScatterPlotDataRow)sender;
-        Series series = chart.Series[row.Name];
-        series.Points.Clear();
-        ConfigureSeries(series, row);
-        FillSeriesWithRowValues(series, row);
-        RecalculateMinMaxPointValues();
-        RecalculateAxesScale(chart.ChartAreas[0]);
-      }
-    }
-    private void Row_NameChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Row_NameChanged), sender, e);
-      else {
-        ScatterPlotDataRow row = (ScatterPlotDataRow)sender;
-        chart.Series[row.Name].Name = row.Name;
-      }
-    }
-    #endregion
-    #region Points Event Handlers
-    private void Points_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<Point2D<double>>> e) {
-      if (InvokeRequired)
-        Invoke(new CollectionItemsChangedEventHandler<IndexedItem<Point2D<double>>>(Points_ItemsAdded), sender, e);
-      else {
-        ScatterPlotDataRow row = null;
-        pointsRowsTable.TryGetValue((IObservableList<Point2D<double>>)sender, out row);
-        if (row != null) {
-          Series rowSeries = chart.Series[row.Name];
-          if (!invisibleSeries.Contains(rowSeries)) {
-            rowSeries.Points.Clear();
-            FillSeriesWithRowValues(rowSeries, row);
-            RecalculateMinMaxPointValues();
-            RecalculateAxesScale(chart.ChartAreas[0]);
-            UpdateYCursorInterval();
-          }
-        }
-      }
-    }
-    private void Points_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<Point2D<double>>> e) {
-      if (InvokeRequired)
-        Invoke(new CollectionItemsChangedEventHandler<IndexedItem<Point2D<double>>>(Points_ItemsRemoved), sender, e);
-      else {
-        ScatterPlotDataRow row = null;
-        pointsRowsTable.TryGetValue((IObservableList<Point2D<double>>)sender, out row);
-        if (row != null) {
-          Series rowSeries = chart.Series[row.Name];
-          if (!invisibleSeries.Contains(rowSeries)) {
-            rowSeries.Points.Clear();
-            FillSeriesWithRowValues(rowSeries, row);
-            RecalculateMinMaxPointValues();
-            RecalculateAxesScale(chart.ChartAreas[0]);
-            UpdateYCursorInterval();
-          }
-        }
-      }
-    }
-    private void Points_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<Point2D<double>>> e) {
-      if (InvokeRequired)
-        Invoke(new CollectionItemsChangedEventHandler<IndexedItem<Point2D<double>>>(Points_ItemsReplaced), sender, e);
-      else {
-        ScatterPlotDataRow row = null;
-        pointsRowsTable.TryGetValue((IObservableList<Point2D<double>>)sender, out row);
-        if (row != null) {
-          Series rowSeries = chart.Series[row.Name];
-          if (!invisibleSeries.Contains(rowSeries)) {
-            rowSeries.Points.Clear();
-            FillSeriesWithRowValues(rowSeries, row);
-            RecalculateMinMaxPointValues();
-            RecalculateAxesScale(chart.ChartAreas[0]);
-            UpdateYCursorInterval();
-          }
-        }
-      }
-    }
-    private void Points_CollectionReset(object sender, CollectionItemsChangedEventArgs<IndexedItem<Point2D<double>>> e) {
-      if (InvokeRequired)
-        Invoke(new CollectionItemsChangedEventHandler<IndexedItem<Point2D<double>>>(Points_CollectionReset), sender, e);
-      else {
-        ScatterPlotDataRow row = null;
-        pointsRowsTable.TryGetValue((IObservableList<Point2D<double>>)sender, out row);
-        if (row != null) {
-          Series rowSeries = chart.Series[row.Name];
-          if (!invisibleSeries.Contains(rowSeries)) {
-            rowSeries.Points.Clear();
-            FillSeriesWithRowValues(rowSeries, row);
-            RecalculateMinMaxPointValues();
-            RecalculateAxesScale(chart.ChartAreas[0]);
-            UpdateYCursorInterval();
-          }
-        }
-      }
-    }
-    #endregion
-    #endregion
-
-    #region Chart Event Handlers
-    private void chart_MouseDown(object sender, MouseEventArgs e) {
-      HitTestResult result = chart.HitTest(e.X, e.Y);
-      if (result.ChartElementType == ChartElementType.LegendItem) {
-        ToggleSeriesVisible(result.Series);
-      }
-    }
-    private void chart_MouseMove(object sender, MouseEventArgs e) {
-      HitTestResult result = chart.HitTest(e.X, e.Y);
-      if (result.ChartElementType == ChartElementType.LegendItem)
-        this.Cursor = Cursors.Hand;
-      else
-        this.Cursor = Cursors.Default;
-    }
-    private void chart_CustomizeLegend(object sender, CustomizeLegendEventArgs e) {
-      foreach (LegendItem legendItem in e.LegendItems) {
-        var series = chart.Series[legendItem.SeriesName];
-        if (series != null) {
-          bool seriesIsInvisible = invisibleSeries.Contains(series);
-          foreach (LegendCell cell in legendItem.Cells) {
-            cell.ForeColor = seriesIsInvisible ? Color.Gray : Color.Black;
-          }
-        }
-      }
-    }
-    #endregion
-
-    private void ToggleSeriesVisible(Series series) {
-      if (!invisibleSeries.Contains(series)) {
-        series.Points.Clear();
-        invisibleSeries.Add(series);
-        RecalculateMinMaxPointValues();
-      } else {
-        invisibleSeries.Remove(series);
-        if (Content != null) {
-
-          var row = (from r in Content.Rows
-                     where r.Name == series.Name
-                     select r).Single();
-          FillSeriesWithRowValues(series, row);
-          RecalculateMinMaxPointValues();
-          this.chart.Legends[series.Legend].ForeColor = Color.Black;
-          RecalculateAxesScale(chart.ChartAreas[0]);
-          UpdateYCursorInterval();
-        }
-      }
-    }
-
-    private void RecalculateMinMaxPointValues() {
-      yMin = xMin = double.MaxValue;
-      yMax = xMax = double.MinValue;
-      foreach (var s in chart.Series.Where(x => x.Enabled)) {
-        foreach (var p in s.Points) {
-          double x = p.XValue, y = p.YValues[0];
-          if (xMin > x) xMin = x;
-          if (xMax < x) xMax = x;
-          if (yMin > y) yMin = y;
-          if (yMax < y) yMax = y;
-        }
-      }
-    }
-
-    private void FillSeriesWithRowValues(Series series, ScatterPlotDataRow row) {
-      for (int i = 0; i < row.Points.Count; i++) {
-        var value = row.Points[i];
-        DataPoint point = new DataPoint();
-        if (IsInvalidValue(value.X) || IsInvalidValue(value.Y))
-          point.IsEmpty = true;
-        else {
-          point.XValue = value.X;
-          point.YValues = new double[] { value.Y };
-        }
-        series.Points.Add(point);
-      }
-    }
-
-    #region Helpers
-    private MarkerStyle ConvertPointStyle(ScatterPlotDataRowVisualProperties.ScatterPlotDataRowPointStyle pointStyle) {
-      switch (pointStyle) {
-        case ScatterPlotDataRowVisualProperties.ScatterPlotDataRowPointStyle.Circle:
-          return MarkerStyle.Circle;
-        case ScatterPlotDataRowVisualProperties.ScatterPlotDataRowPointStyle.Cross:
-          return MarkerStyle.Cross;
-        case ScatterPlotDataRowVisualProperties.ScatterPlotDataRowPointStyle.Diamond:
-          return MarkerStyle.Diamond;
-        case ScatterPlotDataRowVisualProperties.ScatterPlotDataRowPointStyle.Square:
-          return MarkerStyle.Square;
-        case ScatterPlotDataRowVisualProperties.ScatterPlotDataRowPointStyle.Star4:
-          return MarkerStyle.Star4;
-        case ScatterPlotDataRowVisualProperties.ScatterPlotDataRowPointStyle.Star5:
-          return MarkerStyle.Star5;
-        case ScatterPlotDataRowVisualProperties.ScatterPlotDataRowPointStyle.Star6:
-          return MarkerStyle.Star6;
-        case ScatterPlotDataRowVisualProperties.ScatterPlotDataRowPointStyle.Star10:
-          return MarkerStyle.Star10;
-        case ScatterPlotDataRowVisualProperties.ScatterPlotDataRowPointStyle.Triangle:
-          return MarkerStyle.Triangle;
-        default:
-          return MarkerStyle.None;
-      }
-    }
-
-    protected static bool IsInvalidValue(double x) {
-      return double.IsNaN(x) || x < (double)decimal.MinValue || x > (double)decimal.MaxValue;
     }
     #endregion
Index: branches/MemPRAlgorithm/HeuristicLab.Analysis/3.3/DataVisualization/ScatterPlotDataRowVisualProperties.cs
===================================================================
--- branches/MemPRAlgorithm/HeuristicLab.Analysis/3.3/DataVisualization/ScatterPlotDataRowVisualProperties.cs	(revision 14557)
+++ branches/MemPRAlgorithm/HeuristicLab.Analysis/3.3/DataVisualization/ScatterPlotDataRowVisualProperties.cs	(revision 14562)
@@ -45,4 +45,14 @@
     }
     #endregion
+    #region
+    public enum ScatterPlotDataRowRegressionType {
+      None,
+      Linear,
+      Polynomial,
+      Exponential,
+      Logarithmic,
+      Power
+    }
+    #endregion
 
     private Color color;
@@ -101,4 +111,49 @@
       }
     }
+    private ScatterPlotDataRowRegressionType regressionType;
+    public ScatterPlotDataRowRegressionType RegressionType {
+      get { return regressionType; }
+      set {
+        if (regressionType != value) {
+          regressionType = value;
+          OnPropertyChanged("RegressionType");
+        }
+      }
+    }
+    private int polynomialRegressionOrder;
+    public int PolynomialRegressionOrder {
+      get { return polynomialRegressionOrder; }
+      set {
+        if (polynomialRegressionOrder != value) {
+          polynomialRegressionOrder = value;
+          OnPropertyChanged("PolynomialRegressionOrder");
+        }
+      }
+    }
+    private bool isRegressionVisibleInLegend;
+    public bool IsRegressionVisibleInLegend {
+      get { return isRegressionVisibleInLegend; }
+      set {
+        if (isRegressionVisibleInLegend != value) {
+          isRegressionVisibleInLegend = value;
+          OnPropertyChanged("IsRegressionVisibleInLegend");
+        }
+      }
+    }
+    private string regressionDisplayName;
+    public string RegressionDisplayName {
+      get { return regressionDisplayName ?? string.Empty; }
+      set {
+        if (regressionDisplayName != value) {
+          if (value == null && regressionDisplayName != string.Empty) {
+            regressionDisplayName = string.Empty;
+            OnPropertyChanged("RegressionDisplayName");
+          } else if (value != null) {
+            regressionDisplayName = value;
+            OnPropertyChanged("RegressionDisplayName");
+          }
+        }
+      }
+    }
 
     #region Persistence Properties
@@ -127,4 +182,24 @@
       get { return displayName; }
       set { displayName = value; }
+    }
+    [Storable(Name = "RegressionType")]
+    private ScatterPlotDataRowRegressionType StorableRegressionType {
+      get { return regressionType; }
+      set { regressionType = value; }
+    }
+    [Storable(Name = "PolynomialRegressionOrder", DefaultValue = 2)]
+    private int StorablePolynomialRegressionOrder {
+      get { return polynomialRegressionOrder; }
+      set { polynomialRegressionOrder = value; }
+    }
+    [Storable(Name = "IsRegressionVisibleInLegend", DefaultValue = true)]
+    private bool StorableIsRegressionVisibleInLegend {
+      get { return isRegressionVisibleInLegend; }
+      set { isRegressionVisibleInLegend = value; }
+    }
+    [Storable(Name = "RegressionDisplayName")]
+    private string StorableRegressionDisplayName {
+      get { return regressionDisplayName; }
+      set { regressionDisplayName = value; }
     }
     #endregion
@@ -139,4 +214,8 @@
       this.displayName = original.displayName;
       this.isVisibleInLegend = original.isVisibleInLegend;
+      this.regressionType = original.regressionType;
+      this.polynomialRegressionOrder = original.polynomialRegressionOrder;
+      this.isRegressionVisibleInLegend = original.isRegressionVisibleInLegend;
+      this.regressionDisplayName = original.regressionDisplayName;
     }
     public ScatterPlotDataRowVisualProperties() {
@@ -146,4 +225,8 @@
       displayName = String.Empty;
       isVisibleInLegend = true;
+      regressionType = ScatterPlotDataRowRegressionType.None;
+      polynomialRegressionOrder = 2;
+      isRegressionVisibleInLegend = true;
+      regressionDisplayName = string.Empty;
     }
     public ScatterPlotDataRowVisualProperties(string displayName)
Index: branches/MemPRAlgorithm/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs
===================================================================
--- branches/MemPRAlgorithm/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs	(revision 14557)
+++ branches/MemPRAlgorithm/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs	(revision 14562)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 using System.ComponentModel;
 using System.Drawing;
@@ -200,10 +201,16 @@
       }
 
+      var elementNames = Content.ElementNames.ToList();
       for (int i = minRowIndex; i <= maxRowIndex; i++) {
         DataGridViewColumn column = dataGridView.Columns.GetFirstColumn(DataGridViewElementStates.Visible);
         DataGridViewCell cell = dataGridView[column.Index, i];
         if (cell.Selected) {
-          s.Append(Content.ElementNames.ElementAt(i));
-          s.Append("\t");
+          if (i < elementNames.Count) {
+            s.Append(elementNames[i]);
+            s.Append("\t");
+          } else if (elementNames.Count > 0) {
+            s.Append("Index " + i);
+            s.Append("\t");
+          }
           s.Append(Content.GetValue(i));
           s.Append(Environment.NewLine);
@@ -213,5 +220,11 @@
     }
     private void PasteValuesToDataGridView() {
-      string[] values = SplitClipboardString(Clipboard.GetText());
+      Tuple<string, string>[] values = null;
+      try {
+        values = SplitClipboardString(Clipboard.GetText()).ToArray();
+      } catch (ArgumentException ex) {
+        MessageBox.Show(this, ex.Message, "Error while parsing clipboard text.", MessageBoxButtons.OK, MessageBoxIcon.Error);
+        return;
+      }
       int rowIndex = 0;
       if (dataGridView.CurrentCell != null)
@@ -219,11 +232,55 @@
 
       if (Content.Length < rowIndex + values.Length) Content.Length = rowIndex + values.Length;
-      for (int row = 0; row < values.Length; row++)
-        Content.SetValue(values[row], row + rowIndex);
-    }
-    private string[] SplitClipboardString(string clipboardText) {
+      for (int row = 0; row < values.Length; row++) {
+        Content.SetValue(values[row].Item2, row + rowIndex);
+      }
+      if (values.Any(x => !string.IsNullOrEmpty(x.Item1))) {
+        var elementNames = Content.ElementNames.ToList();
+        for (int row = 0; row < values.Length; row++) {
+          if (row + rowIndex < elementNames.Count)
+            elementNames[row + rowIndex] = values[row].Item1;
+          else elementNames.Add(values[row].Item1);
+        }
+        Content.ElementNames = elementNames;
+      }
+    }
+    private IEnumerable<Tuple<string, string>> SplitClipboardString(string clipboardText) {
       if (clipboardText.EndsWith(Environment.NewLine))
         clipboardText = clipboardText.Remove(clipboardText.Length - Environment.NewLine.Length);  //remove last newline constant
-      return clipboardText.Split(new string[] { Environment.NewLine, "\t" }, StringSplitOptions.None);
+
+      var lines = clipboardText.Split(new [] { Environment.NewLine }, StringSplitOptions.None);
+      var tabSep = new[] { '\t' };
+      if (lines.Length > 2) {
+        // Case 1: Each line contains either "elementName \t value" or just "value" (one or two vertical vectors)
+        foreach (var l in lines) {
+          var row = l.Split(tabSep, StringSplitOptions.RemoveEmptyEntries);
+          if (row.Length > 2) throw new ArgumentException("Clipboard may have either at most two rows or at most two columns.");
+          if (row.Length == 2) yield return Tuple.Create(row[0], row[1]);
+          else if (row.Length == 1) yield return Tuple.Create(string.Empty, row[0]);
+          else yield return Tuple.Create(string.Empty, string.Empty);
+        }
+      } else if (lines.Length == 2) {
+        var firstLine = lines[0].Split(tabSep, StringSplitOptions.None);
+        var secondLine = lines[1].Split(tabSep, StringSplitOptions.None);
+        if (firstLine.Length <= 2 && secondLine.Length <= 2) {
+          // Case 2a: The two lines contain either "elementName \t value" or just "value" (one or two vertical vectors)
+          yield return firstLine.Length >= 2 ? Tuple.Create(firstLine[0], firstLine[1]) : Tuple.Create(string.Empty, firstLine[0]);
+          yield return secondLine.Length >= 2 ? Tuple.Create(secondLine[0], secondLine[1]) : Tuple.Create(string.Empty, secondLine[0]);
+        } else {
+          // Case 2b: The first line contains the elementNames, the second line contains the values (two horizontal vectors)
+          var max = Math.Max(firstLine.Length, secondLine.Length);
+          for (var i = 0; i < max; i++) {
+            var elemName = i < firstLine.Length ? firstLine[i] : string.Empty;
+            var value = i < secondLine.Length ? secondLine[i] : string.Empty;
+            yield return Tuple.Create(elemName, value);
+          }
+        }
+      } else if (lines.Length == 1) {
+        // Case 3: The line contains the values (one horizontal vector)
+        var entries = lines[0].Split(tabSep, StringSplitOptions.None);
+        foreach (var e in entries) {
+          yield return Tuple.Create(string.Empty, e);
+        }
+      }
     }
     #endregion
